const _path = require("path");
const {
   split_with_nl_ignore_op,
   split_with_wsnl
} = require("nv-string-split");

const TYPD = {
   "-": "file",
   b:"blk_dev",
   c:"char_dev",
   d:"dir",
   l:"slink",
   n:"net",
   p:"fifo",
   s:"sock"
}

const parse_one_permission = (s,si)=>{
   let read  = s[si]   === 'r';
   let write = s[si+1] === 'w';
   let exec  = s[si+2] === 'x';
   return({read,write,exec})
}

const parse_permission = (s,si=0)=> {
   let user   = parse_one_permission(s,si+0);
   let group  = parse_one_permission(s,si+3);
   let others = parse_one_permission(s,si+6); 
   return({user,group,others})
}

const parse_type_permission = (s)=> {
   let type = TYPD[s[0]];
   let permission = parse_permission(s,1);
   return({type,permission})
}

const ls_al = (s,p="")=> {
        let arr = split_with_nl_ignore_op(s);
        arr = arr[0];
        let head = arr.shift();
        let total = Number(split_with_wsnl(head+"\n",undefined,[])[0][1]);
        let lines = [];
        for(let ln of arr) {
           let eles = split_with_wsnl(ln+"\n",undefined,[])[0];
           let d = {
	       type:TYPD[eles[0][0]],
	       permission: parse_permission(eles[0],1),
               hard_link_cnt: Number(eles[1]),
               owner: eles[2],
               group: eles[3],
               bytsz: Number(eles[4]),
               date:  new Date(`${eles[5]} ${eles[6]} ${eles[7]}`),
               path:  _path.join(p,eles[8])
           }
	   lines.push(d)
        }
        let rslt = {
	    brief:  {total},
            detail:  lines
        }
        return(rslt)
}


module.exports = {
    ls_al,
    TYPD,
    parse_permission,
    parse_type_permission
}
